import javax.swing.*;
import java.awt.*;


/** Create a component that paints our "art".
 * @author Byron Weber Becker */
public class ArtComponent extends JComponent
{
   public ArtComponent()
   {  super();
   	this.setPreferredSize(new Dimension(300,300));
   }

   /** Paint the component with our "art". */
   public void paintComponent(Graphics g)
   {  // boilerplate set-up
      super.paintComponent(g);
      Graphics2D g2 = (Graphics2D) g;
      BasicStroke stroke = new BasicStroke(0.01F);
      g2.scale(this.getWidth()/10, this.getHeight()/10);
      g2.setStroke(stroke);

      // draw our "art"
      for (int line = 0; line < 10; line++)
      {  g2.drawLine(1, 1, 9, line);
      }
      
   }
}
