import becker.robots.Icon;
import java.awt.*;

/** Create a robot icon that looks more like a robot.
 * @author Byron Weber Becker */
public class CustomIcon extends Icon
{
   public CustomIcon()
   {  super();
   }

   protected void renderImage(Graphics2D g2, int width, int height)
   {  // Icons are 1x1.  Scale to an 11x11 grid.
      g2.scale(1.0/11, 1.0/11);
      BasicStroke stroke = new BasicStroke(1.0F/11);
      g2.setStroke(stroke);

      g2.setColor(Color.black);
      // body
      g2.fillRoundRect(4, 5, 3, 3, 1, 1);
      // shoulders
      g2.fillRect(3, 6, 1, 1);
      g2.fillRect(7, 6, 1, 1);
      // arms
      g2.fillOval(3, 4, 1, 3);
      g2.fillOval(7, 4, 1, 3);
   }
}