import becker.robots.*;
import java.awt.Color;

/** A Lamp is a special kind of thing which appears differently depending
    on whether it is "on" or "off".

 @author Byron Weber Becker */
public class Lamp extends Thing
{
   /** Construct a new Lamp.
       @param theCity the City where the Lamp will reside.
       @param avenue the initial avenue.
       @param street the initial street. */
	public Lamp(City theCity, int avenue, int street)
	{	super(theCity, avenue, street);
      this.turnOff();
	}

   /** Turn the lamp "on". */
   public void turnOn()
   {  Color onColor = new Color(255, 255, 200, 150);
      //Color onColor = new Color(255, 255, 200);
      CircleIcon onIcon = new CircleIcon(onColor, 0.75);
      this.setIcon(onIcon);
   }

   /** Turn the lamp "off". */
   public void turnOff()
   {  Color offColor = new Color(0, 0, 0);
      CircleIcon offIcon = new CircleIcon(offColor, 0.25);
      this.setIcon(offIcon);
   }
}
