import java.awt.*;
import javax.swing.*;

public class StickFigure extends JComponent
{
	public StickFigure ()
	{	super ();
		Dimension prefSize = new Dimension(180, 270);
		this.setPreferredSize(prefSize);
	}

/*
   // A version that does NOT scale the image
	public void paintComponent(Graphics g)
	{  super.paintComponent(g);

      // "erase" the old image by filling the entire area with light gray
      g.setColor(Color.lightGray);
      g.fillRect(0, 0, 500, 500);

      // head
      g.setColor(Color.yellow);
      g.fillOval(60, 0, 60, 60);
      // shirt
      g.setColor(Color.red);
      g.fillRect(0, 60, 180, 30);
      g.fillRect(60, 60, 60, 90);
      // pants
      g.setColor(Color.blue);
      g.fillRect(60, 150, 60, 120);
      g.setColor(Color.black);
      g.drawLine(90, 180, 90, 270);
   }
*/



   // A version that scales the image
	public void paintComponent(Graphics g)
	{  super.paintComponent(g);
	
		// standard stuff to scale the image
      Graphics2D g2 = (Graphics2D)g;
      g2.scale(this.getWidth()/6, this.getHeight()/9);
      BasicStroke stroke = new BasicStroke(1.0F/this.getWidth());
      g2.setStroke(stroke);

      // "erase" the old image by filling the entire area with light gray
      g2.setColor(Color.lightGray);
      g2.fillRect(0,0,6,9);

      this.drawGrid(g2);

		// head
      g2.setColor(Color.yellow);
      g2.fillOval(2, 0, 2, 2);
      
      // shirt
      g2.setColor(Color.red);
      g2.fillRect(0, 2, 6, 1);
      g2.fillRect(2, 2, 2, 3);
      
      // pants
      g2.setColor(Color.blue);
      g2.fillRect(2, 5, 2, 4);
      g2.setColor(Color.black);
      g2.drawLine(3, 6, 3, 9);
	}


   private void drawGrid(Graphics2D g2)
   {  g2.setColor(Color.black);
      for(int i=0; i<8; i++)
      {  g2.drawLine(i, 0, i, 10);
      }
      for(int i=0; i<10; i++)
      {  g2.drawLine(0, i, 8, i);
      }

   }

}
