import becker.io.TextInput;
import becker.io.TextOutput;

/** Information about one person.
 * @author Byron Weber Becker */
public class Contact extends Object 
{
	private String name;
	private String number;
	
	/** Construct a contact given the required information as parameters. */
	public Contact(String aName, String aNumber)
	{	super();
		this.name = aName;
		this.number = aNumber;
	}
	
	/* Construct a contact by reading the required information from a file. 
	 * @param in A file with the file cursor just before the contact record containing
	 * the information for this contact object. */
	public Contact(TextInput fileIn)
	{	super();
		this.name = fileIn.readLine();
		this.number = fileIn.readLine();
	}
	
	/** Save a contact to a file. */
	public void save(TextOutput fileOut)
	{	fileOut.println(this.name);
		fileOut.println(this.number);
	}
	
	/** Does this contact match the given name? */
	public boolean matches(String aName)	{	return this.name.startsWith(aName); }
	
	/** Get the contact's name. */
	public String getName()			{	return this.name;}
	
	/** Get the contact's telephone number. */
	public String getNumber()		{	return this.number;	}
}
