
import karel.robots.*;

/** A new kind of robot that collects flashers from a given number
    of intersections.
 @author Byron Weber Becker */
public class Collector extends Robot
{  private int flasherCount = 0;

	public Collector(City theCity, int avenue, int street, int direction, int numThings)
	{	super(theCity, avenue, street, direction, numThings);
	}

	public void collectFlashers(int numIntersections)
   {  int numMoves = 0;
   	while (numMoves < numIntersections - 1)	// move one fewer times than there are intersections
      {  this.pickFlasherIfPresent();
         this.move();
         numMoves = numMoves + 1;
      }
      this.pickFlasherIfPresent();
   }

   public void pickFlasherIfPresent()
   {  if (this.besideThing(Predicate.aFlasher))
      {  this.pickThing(Predicate.aFlasher);
         this.flasherCount = this.flasherCount + 1;
      }
   }

   public void turnAround()
   {  this.turnLeft();
      this.turnLeft();
   }

   public int numFlashersCollected()
   {  return this.flasherCount;
   }
}
