import becker.robots.*;

/** A robot to harvest one row of things.
 @author Byron Weber Becker */
public class RowHarvester extends Robot
{
   /** Construct a new RowHarvester robot.
       @param theCity the City where the robot will reside.
       @param avenue the robot's initial avenue.
       @param street the robot's initial street.
       @param direction the robot's initial direction. */
	public RowHarvester(City theCity, int avenue, int street, int direction)
	{	super(theCity, avenue, street, direction);
	}

   /** Harvest one row of five things. The robot begins just before
       the row and ends just after it.*/
   public void harvestRow()
   {  this.move();
      this.harvestIntersection();
      this.move();
      this.harvestIntersection();
      this.move();
      this.harvestIntersection();
      this.move();
      this.harvestIntersection();
      this.move();
      this.harvestIntersection();
      this.move();
   }

   /** Harvest the things on one intersection. */
	private void harvestIntersection()
	{  this.pickThing();
	}

} 
 