import becker.robots.*;

/** A class of robot which can traverse an area 5 avenues wide and 6 streets high.
    @author Byron Weber Becker */
public class TraverseAreaRobot extends RobotSE
{
   /** Construct a new TraverseAreaRobot.
       @param theCity the city where the robot will be created.
       @param ave the robot's initial avenue
       @param str the robot's initial street
       @param dir the robot's initial direction, one of {Directions.NORTH, SOUTH, EAST, WEST}. 
       @param numThings the number of things initially in the robot's backpack */
   public TraverseAreaRobot(City theCity, int ave, int str, int dir, int numThings)
   {	super(theCity, ave, str, dir, numThings);
   }
   
   /** Traverse an area.  The robot is assumed to be on the
       north-west corner of the area. */
   public void traverseArea()
   {  this.traverseTwoStreets();
		this.positionForNextStreet();
		this.traverseTwoStreets();
		this.positionForNextStreet();
		this.traverseTwoStreets();
   }

   /** traverse two rows of the field, returning to the same avenue
       but one street farther south. */
	protected void traverseTwoStreets()
	{  this.traverseOneStreet();
		this.goToNextStreet();
		this.traverseOneStreet();
	}

   /** traverse one row of five things. */
	protected void traverseOneStreet()
	{  this.visitIntersection();
		this.move();
		this.visitIntersection();
		this.move();
		this.visitIntersection();
		this.move();
		this.visitIntersection();
		this.move();
		this.visitIntersection();
	}

   /** Go one row south and face west.  The robot must be facing east.  */
	private void goToNextStreet()
	{  this.turnRight();
		this.move();
		this.turnRight();
	}


   /** Position the robot for the next traverse by moving one street
       south and facing west. */
	private void positionForNextStreet()
	{  this.turnLeft();
		this.move();
		this.turnLeft();
	}

   /** traverse the things on one intersection. */
	protected void visitIntersection()
	{  
	}
}
