
import java.awt.Graphics2D;
import java.awt.Color;
import becker.util.Utilities;


/** A second try at the Robot class.  These robots are always constructed
 * at (2,4) facing East.  Robots can move forward and turn left, although 
 * the user cannot determine which way the robot is facing until it moves. 
 *
 * @author Byron Weber Becker */
public class SimpleBot2 extends Paintable
{
   private int avenue = 2;
   private int street = 4;
   private int direction = 0;

   /** Construct a new robot at (2,4) facing East. */
   public SimpleBot2()
   {  super();
   }

   /** Paint the robot at its current location. */
   public void paint(Graphics2D g)
   {  g.setColor(Color.black);
      g.fillOval(this.avenue * 50, this.street * 50, 50, 50);
   }

   /** Move the robot forward 1 intersection. */
   public void move()
   {  this.avenue = this.avenue + this.aveOffset();
      this.street = this.street + this.strOffset();
      Utilities.sleep(400);
   }

   /** Turn the robot left 1/4 turn. */
   public void turnLeft()
   {  this.direction = this.direction + 3;
      Utilities.sleep(400);
   }

   /** Calculate how far the robot should move along the avenue
    @return {-1, 0, or 1} */
   private int aveOffset()
   {  int offset = (int) (Math.cos(this.direction * Math.PI / 2));
      return offset;
   }

   /** Calculate how far the robot should move along the street
    @return {-1, 0, or 1} */
   private int strOffset()
   {  int offset = (int) (Math.sin(this.direction * Math.PI / 2));
      return offset;
   }
}
