

/** The city keeps a list of all the things in the city.  
 * 
 * @author Byron Weber Becker */
public class SimpleCity extends Object
{
   public static final int NUM_AVENUES = 10;
   public static final int NUM_STREETS = 10;
   
   /* The list of things in the city is really a list of all the things that
    * need to be painted.  The list kept in an instance of PaintablesManager. */
   private PaintablesManager pMgr = new PaintablesManager();

   /** Create the city, including the intersections within it. */
   public SimpleCity()
   {  super();

      for (int a = 0; a < NUM_AVENUES; a++)
      {  for (int s = 0; s < NUM_STREETS; s++)
         {  SimpleIntersection i = new SimpleIntersection(a, s);
            this.pMgr.addPaintable(i, 0);
         }
      }
   }

   /** Add a new thing to the list of things in the city.
    * @param p the thing to add to the city
    * @param layer the layer in which it should be painted 
    *     (0=background/intersections,
    *      1=things on intersections, 
    *      2=robots) */
   public void add(Paintable p, int layer)
   {  this.pMgr.addPaintable(p, layer);
   }

   /** Make the list of things to paint accessible to the object that
    * actually does the painting.
    * @return the list of things to paint. */
   public PaintablesManager getPaintablesManager()
   {  return this.pMgr;
   }
}
