
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;


/** Paint all the things in the city's PaintablesManager on the screen.
 *
 * @author Byron Weber Becker */
public class View extends JComponent
{
   private PaintablesManager pMgr;
   private Timer timer;

   /** Construct the view.
    * @thePMgr the stuff to paint */
   public View(PaintablesManager thePMgr)
   {  super();
      this.pMgr = thePMgr;
      this.timer = new Timer(50, new TimerListener());
      this.timer.start();
   }

   /** What we do to paint this component -- paint all the things in
    * the manager.
    * @param g the graphics context where painting takes place. */
   public void paintComponent(Graphics g)
   {  super.paintComponent(g);
   
      Graphics2D g2 = (Graphics2D) g;
      g2.setColor(Color.black);
      this.pMgr.paint(g2);
   }

   /** Trigger a repaint of the entire component periodically so that
    * robots appear to move. */
   private class TimerListener implements ActionListener
   {
      public void actionPerformed(ActionEvent e)
      {  View.this.repaint();
      }
   }
}
