
import javax.swing.*;
import becker.util.Utilities;
import becker.gui.*;

/** Test a thermometer widget for a graphical user interface.
 * @author Byron Weber Becker */
public class Main extends Object
{

   public static void main(String[] args)
   {  // Create three thermometer components
      Thermometer t0 = new Thermometer();
      Thermometer t1 = new Thermometer();
      Thermometer t2 = new Thermometer();

      // Create a panel to hold the thermometers.  Set the layout manager
      // to put them in a row, bottom justified.
      JPanel contents = new JPanel();
      contents.setLayout(new RowLayout());
      contents.add(t0);
      contents.add(t1);
      contents.add(t2);

      // Set up the frame.
      JFrame f = new JFrame();
      f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
      f.setContentPane(contents);
      f.pack();
      f.setVisible(true);

      // Set the temperature of each thermometer.
      t0.setTemperature(0);
      t1.setTemperature(30);
      t2.setTemperature(50);

      // Animate the first thermometer
      
      for(int i=0; i<=50; i++)
      {  t0.setTemperature(i);
         Utilities.sleep(50);
      }
      
      
   }
}
